/*
             LUFA Library
     Copyright (C) Dean Camera, 2017.
  dean [at] fourwalledcubicle [dot] com
           www.lufa-lib.org
*/
/*
  Copyright 2017  Dean Camera (dean [at] fourwalledcubicle [dot] com)
  Permission to use, copy, modify, distribute, and sell this
  software and its documentation for any purpose is hereby granted
  without fee, provided that the above copyright notice appear in
  all copies and that both that the copyright notice and this
  permission notice and warranty disclaimer appear in supporting
  documentation, and that the name of the author not be used in
  advertising or publicity pertaining to distribution of the
  software without specific, written prior permission.
  The author disclaims all warranties with regard to this
  software, including all implied warranties of merchantability
  and fitness.  In no event shall the author be liable for any
  special, indirect or consequential damages or any damages
  whatsoever resulting from loss of use, data or profits, whether
  in an action of contract, negligence or other tortious action,
  arising out of or in connection with the use or performance of
  this software.
*/
#ifndef __BUTTONS_USER_H__
#define __BUTTONS_USER_H__
    /* Includes: */
        // TODO: Add any required includes here
        #include <LUFA/Common/Common.h>
    /* Enable C linkage for C++ Compilers: */
    //     #if defined(__cplusplus)
    //         extern "C" {
    //     #endif
    // /* Preprocessor Checks: */
    //     #if !defined(__INCLUDE_FROM_BUTTONS_H)
    //         #error Do not include this file directly. Include LUFA/Drivers/Board/Buttons.h instead.
    //     #endif
    /* Public Interface - May be used in end-application: */
        /* Macros: */
            #define BUTTONS_BUTTON1     (1 << 4)
            #define BUTTONS_BUTTON2     (1 << 5)

            #define BUTTONS_ALL_BUTTON  (BUTTONS_BUTTON1 | BUTTONS_BUTTON2)
        /* Inline Functions: */
        #if !defined(__DOXYGEN__)
            static inline void Buttons_Init(void)
            {
                DDRD  &= ~BUTTONS_ALL_BUTTON;
                PORTD |=  BUTTONS_ALL_BUTTON;
            }
            static inline void Buttons_Disable(void)
            {
                DDRD  &= ~BUTTONS_ALL_BUTTON;
                PORTD &= ~BUTTONS_ALL_BUTTON;
            }
            static inline uint8_t Buttons_GetStatus(void) ATTR_WARN_UNUSED_RESULT;
            static inline uint8_t Buttons_GetStatus(void)
            {
                return ((PIND & BUTTONS_ALL_BUTTON) ^ BUTTONS_ALL_BUTTON);
            }
        #endif
    /* Disable C linkage for C++ Compilers: */
        // #if defined(__cplusplus)
        //     }
        // #endif
#endif
